/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>

char *all[] = {	 "A", ".-",		"B", "-...",	"C", "-.-.",	"D", "-..",
				 "E", ".",		"F", "..-.",	"G", "--.",		"H", "....",
				 "I", "..",		"J", ".---",	"K", "-.-",		"L", ".-..",
				 "M", "--",		"N", "-.",		"O", "---",		"P", ".--.",
				 "Q", "--.-",	"R", ".-.",		"S", "...",		"T", "-",
				 "U", "..-",	"V", "...-",	"W", ".--",		"X", "-..-",
				 "Y", "-.--",	"Z", "--..",
				 "1", ".----",	"2", "..---",	"3", "...--",	"4", "....-",
				 "5", ".....",	"6", "-....",	"7", "--...",	"8", "---..",
				 "9", "----.",	"0", "-----",
				 "Á", ".--.-",	"Ä", ".-.-",	"É", "..-..",	"Ñ", "--.--",
				 "Ö", "---.",	"Ü", "..--",
				 ".", ".-.-.-",	",", "--..--",	"?", "..--..",	"'", ".----.",
				 "!", "-.-.--",	"/", "-..-.",	"-", "-....-",	"(", "-.--.",
				 ")", "-.--.-",	"&", "-.-.-",	":", "---...",	";", "-.-.-.",
				 "=", "-...-",	"/", "-..-.",	"-", "-....-",	"_", "..--.-",
				 "\"", ".-..-.","@", ".--.-.",	"+", ".-.-.",	"$", "...-..-",
				 "*", ".-...",	"#", "-...-.-",
				 "SOS", "...---...",
				 "\n", "...-.-"," ", " ",
				 nil, nil };

void
morenc(int in, int out)
{
	char c[2];
	int i;

	memset(c, 0, 2);

	while(readn(in, c, 1) > 0) {
		for(i = 0; all[i]; i += 2) {
			if(!cistrcmp(c, all[i])) {
				fprint(out, "%s ", all[i + 1]);
				break;
			}
		}
	}
	fprint(out, "\n");
}

void
mordec(int in, int out)
{
	char cc[18], c[2];
	int i, b;

	b = 0;
	i = 0;

	memset(c, 0, 2);

	while(readn(in, c, 1) > 0) {
		if((c[0] == '.' || c[0] == '-') && i < 16)
			cc[i++] = c[0];
		if(c[0] == ' ') {
			if(i == 0) {
				if(b >= 1) {
					fprint(out, " ");
					b = 0;
				} else
					b++;
				continue;
			}
			for(i = 1; all[i]; i += 2) {
				if(!cistrcmp(cc, all[i])) {
					fprint(out, "%s", all[i - 1]);
					break;
				}
			}
			i = 0;
			memset(cc, 0, 18);
		}
	}
}

void
usage(void)
{
	print("usage: morse [-d]\n");
	exits(0);
}

void
main(int argc, char *argv[])
{
	int dec;

	dec = 0;

	ARGBEGIN {
		case 'd':
			dec = 1;
			break;
		default:
			usage();
	} ARGEND;

	if(dec)
		mordec(0, 1);
	else
		morenc(0, 1);

	exits(0);
}
